'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var Vue = require('vue');
var VueRouter = require('vue-router');
var App = require('@@/plugin-vue/App.vue');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var Vue__default = /*#__PURE__*/_interopDefaultLegacy(Vue);
var VueRouter__default = /*#__PURE__*/_interopDefaultLegacy(VueRouter);
var App__default = /*#__PURE__*/_interopDefaultLegacy(App);

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function renderRoutes(opts) {
  if (opts.routes) {
    return opts.routes.map(function (route, index) {
      var _route$path, _route$path2;

      var passProps = {
        key: route.key || index,
        path: (_route$path = route.path) === null || _route$path === void 0 ? void 0 : _route$path.toLowerCase(),
        name: (_route$path2 = route.path) === null || _route$path2 === void 0 ? void 0 : _route$path2.toLowerCase(),
        component: route.component
      };

      if (route.redirect) {
        return _objectSpread2(_objectSpread2({}, passProps), {}, {
          redirect: route.redirect
        });
      } else {
        return _objectSpread2(_objectSpread2({}, passProps), {}, {
          children: renderRoutes(_objectSpread2(_objectSpread2({}, opts), {}, {
            routes: route.routes
          }))
        });
      }
    });
  }

  return [];
}

function createRouter(opts, routes) {
  Vue__default['default'].use(VueRouter__default['default']);
  var mode = 'history';

  if (opts.mode === 'browser') {
    mode = 'history';
  } else if (opts.mode === 'hash') {
    mode = 'hash';
  } else if (opts.mode === 'memory') {
    mode = 'abstract';
  }

  var router = new VueRouter__default['default']({
    // @ts-ignore
    mode: mode,
    routes: routes
  });
  return router;
}

function renderClient(opts) {
  var container = App__default['default'];

  if (opts.rootElement) {
    var routes = renderRoutes({
      routes: opts.routes
    });
    new Vue__default['default']({
      router: createRouter(opts, routes),
      render: function render(h) {
        return h(container);
      }
    }).$mount("#".concat(opts.rootElement));
  } else {
    return container;
  }
}

exports.renderClient = renderClient;
